# Funcons

## File structure:

- __Boldface words:__
	- a folder containing the items following it

- singular-word:
	- a CBS file specifying a single funcon
	- including any Auxiliary funcons

- plural-word:
	- a CBS file specifying one or more value types
	- including all associated value operations


--------------------------------------------------

- __Values:__
	- values
	- types
	- __Primitive values:__
		- empty-type
		- unit-type
		- booleans
		- atoms
		- unicode-characters
		- strings
		- bits
		- __Numbers:__
			- integers
			- rationals
			- ieee-floats
	- __Composite values:__
		- __Collections:__
			- tuples
			- lists
			- vectors
			- sets
			- multisets
			- maps
			- directed-graphs
		- __Algebraic datatype values:__
			- algebraic-datatypes
			- records
			- variants
			- references
- __Computations:__
	- sorts
	- __Data flow:__
		- effect
		- __Giving:__
			- given-value
			- give
			- given
		- __Binding:__
			- environments
			- environment
			- bind
			- bound
			- scope
			- accumulate
			- __Recursion:__
				- recursive
				- bind-recursively
				- bound-recursively
		- __Storing:__
			- stores
			- store
			- variables
			- __Simple variables:__
				- assign
				- assigned
				- allocate-variable
				- allocate-initialised-variable
				- deallocate-variable
				- current-value
			- __General variables:__
				- general-assign
				- general-assigned
				- allocate-vector
				- allocate-map
		- __Linking:__
			- link-stores
			- link-store
			- links
			- allocate-link
			- allocate-initialised-link
			- set-link
			- follow-link
			- follow-if-link
		- __Generating:__
			- atom-generator
			- fresh-atom
			- fresh-binder
		- __Interacting:__
			- standard-out
			- print
			- print-list
			- standard-in
			- read
	- __Control flow:__
		- __Normal:__
			- __Sequencing:__
				- left-to-right
				- sequential
				- atomic
			- __Choosing:__
				- if-then-else
			- __Iterating:__
				- __Indefinite:__
					- while
					- do-while
				- __Definite:__
					- __Mapping collections:__
						- list-map
						- map-map
						- set-map
						- tuple-map
						- vector-map
						- lists-map
					- __Filtering collections:__
						- list-filter
						- map-filter
						- set-filter
						- multiset-filter
					- __Reducing collections:__
						- list-foldl
						- list-foldr
		- __Abnormal:__
			- stuck
			- __Failing:__
				- signals
				- failed
				- fail
				- else
				- check-true
				- dereference
			- __Throwing:__
				- thrown
				- throw
				- handle-thrown
				- handle-recursively
				- finally
			- __Continuations:__
				- control-signal
				- resume-signal
				- control
				- prompt
				- shift
				- reset
				- abort
				- call-cc
				- hole
				- plug
- __Abstractions:__
	- thunks
	- thunk
	- force
	- is-ground-value
	- __Closures:__
		- close
		- closure
	- __Functions:__
		- lambda
		- apply
		- supply
		- compose
		- uncurry
		- curry
		- partial-apply
	- __Patterns:__
		- patterns
		- pattern-any
		- pattern-bind
		- pattern-prefer
		- pattern-unite
		- case
		- match
		- match-loosely

--------------------------------------------------
